MODULE SOCKPOLL
  

    VAR socketdev socket1;
    VAR string received_string;
    PERS bool performReset;
    PERS string numPart;
    PERS bool terminate:=FALSE;
    PERS num currFrame:=2;
    PERS bool paused:=TRUE;
    PERS num currFac:=0;
    !this value is reported as a double between 0 and 100000, so remember to divide by 100000 loser
    PERS string robState;
    !tell the server what the robot is currently doing: 'p' for playing, 's' for standby
    PERS num fOffset:=35;
    PERS num targLen;
    
    
    PROC main()
        
        runSockBk;
        
    ENDPROC
    
    PROC runSockBk()

        SocketCreate socket1;
        SocketConnect socket1,"127.0.0.1",5515;

        SocketSend socket1\Str:="4,"+NumToStr(targLen,0)+"\0A";
        SocketReceive socket1\Str:=received_string;

        TPWrite "Server wrote - "+received_string;
        received_string:="";
        ! Continue sending and receiving
        SocketSend socket1\Str:=GetSysInfo(\RobotType)+"|"+NumToStr(currFrame,0)+"|"+robState+"\0A";

        WHILE NOT terminate DO

            ! in order to begin with a recieve statement there needs to be another send statement before hand to get things to line up on the server end
            SocketReceive socket1\Str:=received_string;
            robState:="s";

            IF StrMemb(received_string,1,"p") THEN
                paused:=FALSE;
                performReset:=FALSE;
                robState:="p";
            ENDIF

            IF StrMemb(received_string,1,"q") THEN
                paused:=TRUE;

            ENDIF

            IF StrMemb(received_string,1,"r") THEN
                paused:=TRUE;
                currFrame:=2;
                performReset:=TRUE;

            ENDIF

            IF StrMemb(received_string,1,";") THEN
                terminate:=TRUE;
            ENDIF

            parseMsg;
            !playSingleFrame;
            
            SocketSend socket1\Str:=GetSysInfo(\RobotType)+"|"+NumToStr(currFrame,0)+"|"+robState+"\0A";

        ENDWHILE

        ! Shutdown the connection
        !SocketSend socket1\Str:="Shutdown connection";
        !SocketReceive socket1\Str:=received_string;
        !TPWrite "Server wrote - "+received_string;
        SocketClose socket1;
    ENDPROC
    
    PROC parseMsg()

        VAR bool ok;
        VAR String diff;
        VAR num out;
        VAR num len;
        VAR num found;
        VAR num found2;
        found:=StrFind(received_string,3,",");
        found2:=StrFind(received_string,3,"|");
        len:=StrLen(received_string)-2;
        numPart:=StrPart(received_string,3,found-4);

        ok:=StrToVal(numPart,out);
        currFac:=out;

        numPart:=StrPart(received_string,found+1,found2-found-1);
        ok:=StrToVal(numPart,out);
        fOffset:=out;

        !RETURN out;

    ENDPROC
    
ENDMODULE